/* Copyright 1998 by Artur Merke (All rights reserved) */

#ifndef _GEOMETRY_H_
#define _GEOMETRY_H_

struct Punkt{
  float x1,x2;
};

class Geometry {
public:
   static int intesect_circle1_with_circle2(float &x1, float &y1, float &x2, float &y2,
                   float Cx1, float Cy1, float r1, float Cx2, float Cy2, float r2);

   static int intesect_circle_with_x_line(float &x1,float &y1, float &x2, float &y2,
                   float Cx, float Cy, float r,float  xline);

   static int intesect_circle_with_y_line(float &x1,float &y1, float &x2, float &y2,
                   float Cx, float Cy, float r, float yline);

   /* gegeben 2 Punkte (x1,y1) (x2,y2), gesucht sind die beiden Kreise, auf denen die Punkte
      (px,py) liegen, so dass der Winkel zwischen den Vektoren (x1-px,y1-py) und 
      (x2-px,y2-py) den Wert von "angle" hat. Bem: ist der Winkel >90 Grad, so liegen die
      gesuchten Punkte auf dem "laengeren" Bogen des Kreise, wobei der Kreis durch die 
      Strecke von (x1,y1) und (x2,y2) in zwei Bogenabschnitte geteilt wird */
   static int circles_with_angle(float &Cx1, float &Cy1, float &Cx2, float &Cy2,float &radius,
                       float x1, float y1, float x2, float y2, float  angle);

  
   static void rotate_vector_with_angle_and_normalize(float &x,float &y, float vx, float vy, float angle);
   static void unit_vector_with_angle(float &x,float &y,float angle);
   static float angle_to_point(float x,float y);
   static float normalize_angle(float a);   
   static float deg_2_rad(float a);
   static float rad_2_deg(float a);

   

// nicht ausgereift!
   static void compute_xy(float &x,float &y, float x1, float y1,float dist1, float angle1,
                   float x2, float y2,float dist2, float angle2);
};


#endif








