#ifndef _MONITORTYPES_H
#define _MONITORTYPES_H




/*=====================================================*/
/* es wurden ganze Kompontente aus den Dateien 
   server/netif.C  -> 
   server/types.h 
   uebernommen und enspr. modifiziert
*/

#define NULLCHAR        '\000'

#define SHOW_MODE 1
#define MSG_MODE 2

#define MAX_MESG_SIZE 2048
#define MAX_STRING_SIZE 4096
#define MAX_COLOR_NAME  64
#define MAX_PLAYER      11

/* Arguments for pos_t.enable */
#define	DISABLE			0x00
#define	STAND			0x01
#define	KICK			STAND << 1
#define KICK_FAULT		STAND << 2
#define	GOALIE			STAND << 3
#define CATCH			STAND << 4
#define CATCH_FAULT		STAND << 5
#define BALL_TO_PLAYER	STAND << 6
#define PLAYER_TO_BALL	STAND << 7

/* Arguments for pos_t.side */
#define LEFT    1
#define NEUTRAL 0
#define RIGHT  -1

typedef struct {
        short   enable ;
        short   side ;
        short   unum ;
        short   angle ;
        short   x ;
        short   y ;
} pos_t ;

typedef struct {
        char    name[16] ;
        short   score ;
} team_t ;


typedef struct {
        char    pmode ;
        team_t  team[2] ;
        pos_t   pos[MAX_PLAYER * 2 + 1] ;
        short   time ;
} showinfo_t ;

typedef struct {
        short   board ;
        char    message[MAX_MESG_SIZE] ;
} msginfo_t ;

typedef struct {
        short   x ;
        short   y ;
        char    color[MAX_COLOR_NAME] ;
} pointinfo_t ;

typedef struct {
        short   x ;
        short   y ;
        short   r ;
        char    color[MAX_COLOR_NAME] ;
} circleinfo_t ;

typedef struct {
        short   x1 ;
        short   y1 ;
        short   x2 ;
        short   y2 ;
        char    color[MAX_COLOR_NAME] ;
} lineinfo_t ;

typedef struct {
        short mode ;
        union {
                pointinfo_t             pinfo ;
                circleinfo_t    cinfo ;
                lineinfo_t              linfo ;
        } object ;
} drawinfo_t ;

typedef struct {
        short   mode ;
        union {
                showinfo_t      show ;
                msginfo_t       msg ;
                drawinfo_t      draw ;
        } body ;
} dispinfo_t ;

typedef enum _PlayMode {
        PM_Null,
        PM_BeforeKickOff,
        PM_TimeOver,
        PM_PlayOn,
        PM_KickOff_Left,
        PM_KickOff_Right,
        PM_KickIn_Left,
        PM_KickIn_Right,
        PM_FreeKick_Left,
        PM_FreeKick_Right,
        PM_CornerKick_Left,
        PM_CornerKick_Right,
        PM_GoalKick_Left,
        PM_GoalKick_Right,
        PM_AfterGoal_Left,
        PM_AfterGoal_Right,
        PM_DropBall,
        PM_OffSide_Left,
        PM_OffSide_Right,
        PM_MAX 
} PlayMode ;


#endif
