#ifndef _GLOBALDEF_H_
#define _GLOBALDEF_H_

#include "globaltypes.h"
#include "Vector.h"
#include <math.h>

#define PI M_PI

const int NUM_PLAYERS= 11;

const int NARROW= 0;
const int NORMAL= 1;
const int WIDE=   2;

const int LOW= 0;
const int HIGH= 1;

 
const Value FIELD_BORDER_X = 52.5;
const Value FIELD_BORDER_Y = 34.0;
const Vector MY_GOAL_LEFT_CORNER= Vector(-FIELD_BORDER_X,7.32);
const Vector MY_GOAL_RIGHT_CORNER= Vector(-FIELD_BORDER_X,-7.32);
const Vector HIS_GOAL_LEFT_CORNER= Vector(FIELD_BORDER_X,7.32);
const Vector HIS_GOAL_RIGHT_CORNER= Vector(FIELD_BORDER_X,-7.32);
#define RAD2DEG(x)((int)(x/PI*180.))
#define DEG2RAD(x)((double)(x/180.*PI))

#define DPASS 5
#define DPASS_DIAG DPASS / 1.414

const Vector Pass_Direct = Vector(0,0);
const Vector Pass_Forward = Vector(DPASS,0);
const Vector Pass_Backward = Vector(-DPASS,0);
const Vector Pass_Left = Vector(0,DPASS);
const Vector Pass_Right = Vector(0,-DPASS);
const Vector Pass_LeftForward = Vector(DPASS_DIAG,DPASS_DIAG);
const Vector Pass_RightForward = Vector(DPASS_DIAG,-DPASS_DIAG);
const Vector Pass_LeftBackward = Vector(-DPASS_DIAG,DPASS_DIAG);
const Vector Pass_RightBackward = Vector(-DPASS_DIAG,-DPASS_DIAG);
const Vector Pass_LongForward = Vector(2*DPASS,0);

#define DDRIBBLE 5
#define DDRIBBLE_DIAG DDRIBBLE / 1.414

const Vector Dribble_Forward = Vector(DDRIBBLE,0);
const Vector Dribble_Backward = Vector(-DDRIBBLE,0);
const Vector Dribble_Left = Vector(0,DDRIBBLE);
const Vector Dribble_Right = Vector(0,-DDRIBBLE);
const Vector Dribble_LeftForward = Vector(DDRIBBLE_DIAG,DDRIBBLE_DIAG);
const Vector Dribble_RightForward = Vector(DDRIBBLE_DIAG,-DDRIBBLE_DIAG);
const Vector Dribble_LeftFForward = Vector(DDRIBBLE,DDRIBBLE_DIAG);
const Vector Dribble_RightFForward = Vector(DDRIBBLE,-DDRIBBLE_DIAG);
const Vector Dribble_LeftBackward = Vector(-DDRIBBLE_DIAG,DDRIBBLE_DIAG);
const Vector Dribble_RightBackward = Vector(-DDRIBBLE_DIAG,-DDRIBBLE_DIAG);

#endif
