#ifndef _TOOLS_H
#define _TOOLS_H

#include "globaldef.h"
#include "cmd.h"

class Tools {
 public:
  /** Return the angle in [-Pi,+Pi) */
  static Angle get_angle_between_mPI_pPI(Angle angle);
  /** Return the angle in [0,+2*Pi) */
  static Angle get_angle_between_null_2PI(Angle angle);

  /** Return the absolut size of angle */
  static Angle get_abs_angle(Angle angle);

  /** Return a random integer with 0 <= int < range. */
  static int int_random(int range);

  static Value range_random(Value lo, Value hi);
  
  static int very_random_int(int n);

  inline static bool equal(Value x,Value y,Value epsilon = 0.00001)
    {return(fabs(x-y)<epsilon);};

  /** Return the maximum */
  static Value max(Value a, Value b);
  static Value min(Value a, Value b);
  static int max(int a, int b);
  static int min(int a, int b);

  static Vector get_Lotfuss(Vector x1, Vector x2, Vector p);

  static void predict_state(const Cmd_Main& cmd, Vector &new_player_pos,Vector &new_player_vel, 
			    Value &new_body_dir,
			    Vector &new_ball_pos, Vector &new_ball_vel);  
};

#endif
