/** \file types.h 
This file contains and \b should contain all \b typedefs, \b defines, \b enumerations and such that affect more than one file.
*/

#ifndef _BS2K_TYPES_H_
#define _BS2K_TYPES_H_

#include <math.h>

#if 0 
/* an Alex von Artur: ich hab' all das auskommentiert, da es im Client nicht
gebraucht wird, da aehnliches bereits in globaldef.h definiert ist (insbesondere
View Quality und Width).

Das was Du im deinem Weltmodell brauchst, solltes Du auch dort defnieren (zB.
SIDE_LEFT, Kick_Para etc.

*/

typedef enum View_Width_Enum{NARROW, NORMAL, WIDE} View_Width;
typedef enum View_Quality_Enum{HIGH, LOW} View_Quality;

/* We define Parameter structs for the actions for sake of easier handling. */
typedef struct Kick_Para{
  double power;
  double direction;
} Kick_Parameter;
typedef struct Turn_Para{
  double moment;
} Turn_Parameter;
typedef struct Dash_Para{
  double power;
} Dash_Parameter;
typedef struct Catch_Para{
  double direction;
} Catch_Parameter;
typedef struct Move_Para{
  double x;
  double y;
} Move_Parameter;
typedef struct Turn_Neck_Para{
  double moment;
} Turn_Neck_Parameter;
typedef struct Change_View_Para{
  View_Width view_width;
  View_Quality view_quality;
} Change_View_Parameter;
typedef struct Say_Para{
  char *message;
} Say_Parameter;

#ifndef Bool
#define Bool bool
#endif



/* identifiers from which side we are playing. 
Needed in the new update !
*/

#define SIDE_LEFT 1
#define SIDE_RIGHT -1
#endif

#endif
