/** \file move_defs.h
    All identifiers for moves are defined in this file.
    Please add a short description of the move as a comment too ...
*/

#ifndef _MOVE_DEFS_H_
#define _MOVE_DEFS_H_

enum Move_Id {
 ABSTRACT_MOVE,            /*< The base moves from which the real moves inherit. */

/* MAIN MOVES */
 MAIN_MOVE,                /*< base class for all main moves */
 MOVE_DASH,                /*< a simple dash */
 MOVE_TURN,                /*< a simple turn */
 MOVE_KICK,                /*< a simple kick */
 MOVE_CATCH,               /*< a simple catch */
 MOVE_MOVE,                /*< a simple move */
		       
 MOVE_TURN_INERTIA,        /*< a more sophisticated turn command */
 MOVE_DASH_STAMINA,        /*< a more sophisticated dash command */

 MOVE_1STEP_KICK,          /*< a sophisticated 1 kick move */			       
 MOVE_RUN_TO,              /*< run to a specified position on the field (newBS99)*/
 MOVE_INTERCEPT_BALL,      /*< get close to the ball (newBS99)*/
 MOVE_STOP_BALL,           /*< try to reduce ball speed by a single kick (newBS99)*/
 MOVE_LOOK_AROUND,         /*< try to locate other objects as fast as posssible (newBS99)*/
 MOVE_FACE_BALL,           /*< face the ball (newBS99) */

 NEURO_KICK,               /*< martins neuro kick move (newBS99)*/
 NEURO_CARRY_BALL,         /*< carry the ball to a specified target area*/
 NEURO_DRIBBLE,            /*< carry the ball to a specified target area, consider opponent*/
 NEURO_DRIBBLE2,           /*< dribble to a specified target area, consider opponent*/
 NEURO_INTERCEPT_BALL,     /*< get close to the ball*/
 NEURO_KICK2,              /*< davids evaluation neuro kick move */
 NEURO_STOP_BALL,          /*< slow down a ball in kickrange */
 NEURO_ATTACK,             /*< attack an opponent player with ball */
 NEURO_GO2POS,             /*< neuro version of go2pos, respects obstacles */
 MOVE_GO2POS_BACKWARDS,    /*< very simple go backwards move */
 NEURO_GOALIE_INTERCEPT,   /*< same as neuro-intercept except respeccting catchable area */
 NEURO_HOLD_BALL,          /*< keep ball against an opponent player */

 MOVE_GOALIE_ELLIPSOID,    /*< goalie moves on ellipsoid */
// MOVE_GOALIE_INTERCEPT_BALL, /*< same as neuro-intercept except finished condition */
/* END MAIN MOVES */ 

/* NECK MOVES */
 NECK_MOVE,                /*< base class for all neck moves */
 MOVE_TURN_NECK,          
/* END NECK MOVES */

/* SAY MOVES */
 SAY_MOVE,                 /*< base class for all say moves */
 MOVE_SAY,                
/* END SAY MOVES */

/* VIEW MOVES */
 VIEW_MOVE,                /*< base class for all view moves */
 MOVE_CHANGE_VIEW
/* END VIEW MOVES */

};

#endif //_MOVE_DEFS_H_
