/** \file move_face_ball.h
    this is exactly the "face_ball" move from newBS99. it simply forces 
    turns to get informations about the location of the other objects 
    and myself as fast as possible . 

*/

#ifndef _MOVE_FACE_BALL_H_
#define _MOVE_FACE_BALL_H_

#include <iostream.h>
#include <stdio.h>

#include "move_defs.h"
#include "base_moves.h"
#include "cmd.h"
#include "types.h"
#include "mdp_info.h"

//#include "globals.h"

class Move_Face_Ball : public Main_Move {
  friend class Move_Factory;
 protected:
  int number_of_turns;
  int time_of_turn;
  int last_look_around_time;
  bool turn_left;
  bool ball_invalid;

  struct {
    int search;
    int defend;
    int pass;
    int look;
    int no_spec;
  } stat_extend;

  /** returns turn commands*/
  void execute(Cmd & cmd);
    
  virtual bool final_state();

 public:
  /** constructor */
  Move_Face_Ball();
  /** get the unique id of the move.
      \return move id.
  */ 
  inline int id() {return MOVE_FACE_BALL;}
  /** get a short description of the move */
  const char* id_str() { return "Move_Face_Ball"; }

  void print_statistics();

};


#endif // _MOVE_FACE_BALL_H_
