#include "move_go2pos_backwards.h"
#include "tools.h"
#include "mdp_info.h"

Move_Go2Pos_Backwards::Move_Go2Pos_Backwards(double p_x=-52, double p_y=0, double p_accuracy=1.0, double power=-100){
  target.x = p_x;
  target.y = p_y;
  accuracy = p_accuracy;
  dash_power = power;
}

bool Move_Go2Pos_Backwards::final_state(){
  if (mdpInfo::my_distance_to(target) <= accuracy)
    return true;
  else
    return false;
}

void Move_Go2Pos_Backwards::execute(Cmd & cmd){
  double moment = 0;
  if (fabs(Tools::get_angle_between_null_2PI(mdpInfo::my_angle_to(target)) - M_PI) <= 0.05){
    cmd.cmd_main.set_dash(-fabs(dash_power));
  } else {
    /* we have to consider inertia ! 
       actual_angle = moment/(1.0 + inertia_moment * player_speed)
       -> moment = actual_angle * (1.0 + inertia_moment * player_speed)
     */
    moment = Tools::get_angle_between_mPI_pPI(mdpInfo::my_angle_to(target)-M_PI) * (1.0 + ServerOptions::inertia_moment * mdpInfo::my_vel_abs().norm());

    cmd.cmd_main.set_turn(moment);
  }
}
