/** \file move_go2pos_backwards.h
    We define a very simple move to go backwards...
*/

#include "base_moves.h"
#include "Vector.h"
#include <math.h>

#ifndef _MOVE_GO2POS_BACKWARDS_H_
#define _MOVE_GO2POS_BACKWARDS_H_

class Move_Go2Pos_Backwards : public Main_Move {
  friend class Move_Factory;
 protected:
  /** target position */
  Vector target;
  
  /** accuracy at which we want to reach the position */
  double accuracy;

  /** dash power at which we run ! */
  double dash_power;

  /** returns dash and turn commands*/
  void execute(Cmd & cmd);
  /** The final state of a move is to be defined here.
      Overload this method to implement your own move termination conditions.
      Simply return false if you want the move to be aborted after max_steps steps.
   */
  virtual bool final_state();

  void go_to_point(Cmd & cmd, Vector p, Value accuracy, Value dash_power);
  int last_go_to_point_time;
  int number_of_go_to_point_at_same_time;

public:
  /** constructor */
  Move_Go2Pos_Backwards(double p_x=-52, double p_y=0, double p_accuracy=1.0, double power=-100);
  /** get the unique id of the move.
      \return move id.
  */ 
  inline int id() {return MOVE_GO2POS_BACKWARDS;}
  /** get a short description of the move */
  const char* id_str() { return "Move_Go2Pos_Backwards"; }
};




#endif //_MOVE_GO2POS_BACKWARDS_H_
