/** \file move_intercept_ball.h
    try to get me to the ball as fast as possible.
    this is exactly the "intercept_ball" skill from newBS99.

    - calculates a rendevouz point by relative ball position and ball velocity
    - turns player to face to the calculated rendevouz point and dashes
*/

#ifndef _MOVE_INTERCEPT_BALL_H_
#define _MOVE_INTERCEPT_BALL_H_

#include <iostream.h>
#include <stdio.h>

#include "move_defs.h"
#include "base_moves.h"
#include "cmd.h"
#include "types.h"
#include "mdp_info.h"

//#include "globals.h"

class Move_Intercept_Ball : public Main_Move {
  friend class Move_Factory;
 protected:
  int safety_steps;
  
  /** returns dash and turn commands*/
  void execute(Cmd & cmd);
  /** The final state of a move is to be defined here.
      Overload this method to implement your own move termination conditions.
      Simply return false if you want the move to be aborted after max_steps steps.
   */
  virtual bool final_state();

 public:
  /** constructor */
  Move_Intercept_Ball(int p_safety_steps=0);
  /** get the unique id of the move.
      \return move id.
  */ 
  inline int id() {return MOVE_INTERCEPT_BALL;}
  /** get a short description of the move */
  const char* id_str() { return "Move_Intercept_Ball"; }
};


#endif // _MOVE_INTERCEPT_BALL_H_
