#include "move_look_around.h"
#include "tools.h"
#include "options.h"
#include "mdp_info.h"

Move_Look_Around::Move_Look_Around(){
  number_of_turns = 0;
  time_of_turn = 0;
  max_turns = 4;
}

bool Move_Look_Around::final_state(){
  if(number_of_turns > max_turns){
    number_of_turns = 0;
    max_turns = 4;
    return true;
  }
  else
    return false;
}


void Move_Look_Around::execute(Cmd & cmd){

  max_turns = (int)(2.0*PI/(0.9*mdpInfo::view_angle_width_rad()) + 1);

  if(!(   mdpInfo::mdp->play_mode == MDPstate::PM_my_KickIn
       || mdpInfo::mdp->play_mode == MDPstate::PM_my_FreeKick
       || mdpInfo::mdp->play_mode == MDPstate::PM_my_CornerKick
       || mdpInfo::mdp->play_mode == MDPstate::PM_PlayOn)){
    // maybe cycles are not counted, so turn by the half of view angle, but turn in every step
    cmd.cmd_main.set_turn(0.4 * mdpInfo::view_angle_width_rad());
    return;
  }

  if(mdpInfo::mdp->time_of_last_update > time_of_turn){
    number_of_turns++;
    cmd.cmd_main.set_turn(0.9 * mdpInfo::view_angle_width_rad() );
    time_of_turn = mdpInfo::mdp->time_current;
    if(Tools::get_abs_angle(mdpInfo::mdp->me->neck_angle_rel()) > 0 ) // set neck dir = body dir
      cmd.cmd_neck.set_turn(- mdpInfo::mdp->me->neck_angle_rel()); 
    else
      cmd.cmd_neck.set_turn(0);  // lock the turn neck command when turning
  }
  else
    cmd.cmd_neck.set_turn(0);  // lock the turn neck command when looking around
}

