/** \file move_look_around.h
    this is exactly the "look_around" move from newBS99. it simply forces 
    turns to get informations about the location of the other objects 
    and myself as fast as possible . 

*/

#ifndef _MOVE_LOOK_AROUND_H_
#define _MOVE_LOOK_AROUND_H_

#include <iostream.h>
#include <stdio.h>

#include "move_defs.h"
#include "base_moves.h"
#include "cmd.h"
#include "types.h"
#include "mdp_info.h"

//#include "globals.h"

class Move_Look_Around : public Main_Move {
  friend class Move_Factory;
 protected:
  int number_of_turns;
  int time_of_turn;
  int max_turns;
  
  /** returns turn commands*/
  void execute(Cmd & cmd);
  virtual bool final_state();

 public:
  /** constructor */
  Move_Look_Around();
  /** get the unique id of the move.
      \return move id.
  */ 
  inline int id() {return MOVE_LOOK_AROUND;}
  /** get a short description of the move */
  const char* id_str() { return "Move_Look_Around"; }
};


#endif // _MOVE_LOOK_AROUND_H_
