#include "move_run_to.h"
#include "tools.h"
#include "options.h"
#include "mdp_info.h"

Move_Run_To::Move_Run_To(double p_x=-30, double p_y=0, double p_accuracy=2.0){
  x = p_x;
  y = p_y;
  accuracy = p_accuracy;
}

bool Move_Run_To::final_state(){
  Vector target;
  target.x = x;
  target.y = y;

  if(mdpInfo::my_distance_to(target) <= accuracy)
    return true;
  else
    return false;  
}

void Move_Run_To::execute(Cmd & cmd){
  Vector target;
  target.x = x;
  target.y = y;

  go_to_point(cmd, target, accuracy, 75);
}


void Move_Run_To::go_to_point(Cmd & cmd, Vector p, Value buffer, Value dash_power)
{
  // Proof if an error with recursive call of function:
  if (last_go_to_point_time != mdpInfo::mdp->time_current) {
    last_go_to_point_time = mdpInfo::mdp->time_current;
    number_of_go_to_point_at_same_time = 0;
  } else {
    number_of_go_to_point_at_same_time++;
  }
  if (number_of_go_to_point_at_same_time > 5) return;
    
  if (ClientOptions::doku_level == 789) printf("ActionSkills::go_to_point(...) BEGINN\n");

  //don`t know where I am? => turn
  if ( !mdpInfo::is_my_pos_valid() ) {
    double moment = mdpInfo::view_angle_width_rad();
    cmd.cmd_main.set_turn(moment);
    return;
  }

  //if ( mdpInfo::my_distance_to(p) <= buffer ){
  // return;
  //}

  float target_ang  = Tools::get_angle_between_mPI_pPI(mdpInfo::my_angle_to(p));
  // printf("ActionSkills::go_to_point: target_ang = %f \n",target_ang );
  //float target_dist = mdpInfo::my_distance_to(p);

#if 0
  const FPlayer *player;
  float    dodge_dist; //Mem->CP_dodge_distance_buffer,target_dist);
  if(target_dist<= 3.5) dodge_dist = target_dist;
  else dodge_dist = 3.5;
  Angle dodge_ang  = (PI/180)*25; // Mem->CP_dodge_angle_buffer;
  if ( (player = mdpInfo::get_a_player_in_area( dodge_dist, dodge_ang, 0, target_ang - dodge_ang))
       != NULL ){
    if ( mdpInfo::number_of_players_in_area( dodge_dist, 2*dodge_ang) ){
      /* Target close, so no players will be within in the next iteration ==> dash */
      Vector new_target = mdpInfo::polar2global_pos(.8,mdpInfo::my_angle_to( Vector( player->pos_x.v, player->pos_y.v) ) + (PI/180)*90);
      go_to_point(cmd, new_target, buffer, dash_power);
    }
    else{
      cmd.cmd_main.set_dash(ServerOptions::stamina_inc_max-5);
      return;
    }
    return;
  }
#endif
  
  // printf("ActionSkills::go_to_point: target_ang = %f \n",target_ang );
  if ( fabs(target_ang) > (PI/180)*5) { // Mem->CP_max_go_to_point_angle_err ){
    cmd.cmd_main.unset_lock();
    cmd.cmd_main.set_turn(target_ang);
    return;
  }

  if ( mdpInfo::mdp->me->stamina.v >= ServerOptions::stamina_max*ServerOptions::recover_dec_thr + dash_power)
    cmd.cmd_main.set_dash(dash_power);
  else{  
    cmd.cmd_main.set_dash(ServerOptions::stamina_inc_max-5);
  } 
}
