/** \file move_run_to.h
    this is exactly the "go_to_point" skill from newBS99. it simply turns and dashes 
    the player to the specified target including some obstacle considerations. 

*/

#ifndef _MOVE_RUN_TO_H_
#define _MOVE_RUN_TO_H_

#include <iostream.h>
#include <stdio.h>

#include "move_defs.h"
#include "base_moves.h"
#include "cmd.h"
#include "types.h"
#include "mdp_info.h"

//#include "globals.h"

class Move_Run_To : public Main_Move {
friend class Move_Factory;
protected:
 double x;
 double y;

 double accuracy;

  /** returns dash and turn commands*/
  void execute(Cmd & cmd);
  /** The final state of a move is to be defined here.
      Overload this method to implement your own move termination conditions.
      Simply return false if you want the move to be aborted after max_steps steps.
   */
  virtual bool final_state();

  void go_to_point(Cmd & cmd, Vector p, Value accuracy, Value dash_power);
  int last_go_to_point_time;
  int number_of_go_to_point_at_same_time;

public:
  /** constructor */
  Move_Run_To(double p_x=-30, double p_y=0, double p_accuracy=2.0);
  /** get the unique id of the move.
      \return move id.
  */ 
  inline int id() {return MOVE_RUN_TO;}
  /** get a short description of the move */
  const char* id_str() { return "Move_Run_To"; }
};


#endif // _MOVES_RUN_TO_H_
