#ifndef NEURO_STOP_BALL_H_
#define NEURO_STOP_BALL_H_

#include "neuro_move.h"


class Neuro_Stop_Ball : public Neuro_Move {
  friend class Move_Factory;
  
  /** velocity the move tries to slown down ball to */
  float max_velocity;
 
  /** allowed max distance to ball */
  float max_ball_dist;

  /** specifies the successful terminal states of the neuro intercept ball move */ 
  bool is_success(const Neuro_State& state);

  /** specifies the unsuccessful terminal states of the neuro intercept ball move */ 
  bool is_failure(const Neuro_State& state);
   
  /** specifies the net input for the neuro intercept ball move */ 
  void get_features(const Neuro_State& state, float *net_input);

  /** print a neuro intercept ball state */ 
  void print_state(const Neuro_State&);
  
  /** this method generates a set of allowed actions for a given state */ 
  void generate_actions(const Neuro_State&);

 public:
 
  /** constructor */
  Neuro_Stop_Ball(float p_max_velocity=0.7);
  ~Neuro_Stop_Ball();

  /** specifies final states of neuro intercept */
  bool final_state();
 
  /** get the unique id of the move */ 
  inline int id() {return NEURO_STOP_BALL;}

  /** get a short description of the move */
  const char* id_str() { return "Neuro_Stop_Ball"; }
};

#endif
