/** \file policy_dynamic_neck
*/

#ifndef _POLICY_DYNAMIC_NECK_H_
#define _POLICY_DYNAMIC_NECK_H_

#include "base_policies.h"
#include "move_factory.h"

//#include "globals.h"

/**
 */
class  Dynamic_Neck_Policy : public Neck_Policy {

 protected:
  
 public:

  Dynamic_Neck_Policy();

  /** get the unique id of the policy.
      \return policy id.
  */ 
  inline virtual int id() {return DYNAMIC_NECK_POLICY;}

  virtual Neck_Move* playon();
 private:
  int time_of_turn;
  int time_attacker_seen;
  Value turnback2_scandir;
  Neck_Move* neck_standard();
  Neck_Move* goalie_neck();
  Neck_Move* neck_intercept_ball();
  Neck_Move* neck_lookfor_goalie();
  Neck_Move* neck_carefor_attackers();
  
};

#endif //_POLICY_DYNAMIC_NECK_H_

