#include "policy_dynamic_say.h"
#include "mdp_info.h"
#include <stdlib.h>
#include <stdio.h>
#include "tools.h"
#include "valueparser.h"
#include "options.h"
#include "cmd.h"
#include "logger.h"

Dynamic_Say_Policy::Dynamic_Say_Policy() {
  communication_zone = 1000; // communicate in every case
  quiet_time = 5;
  last_sent = 0;

  ball_wasin_kickrange = false;
  ball_wasin_feelrange = false;

  ValueParser vp(CommandLineOptions::policy_conf,"Dynamic_Say_Policy");
  vp.get("quiet_time", quiet_time );
  vp.get("communication_zone", communication_zone );
}

bool Dynamic_Say_Policy::in_communication_zone(){
  if(mdpInfo::mdp->play_mode != MDPstate::PM_PlayOn)
    return true;
  if(!mdpInfo::is_ball_pos_valid())
    return false;
  Value ballx=mdpInfo::ball_pos_abs().x;
  Value myx =mdpInfo::my_pos_abs().x;

  if(fabs(ballx - myx) > communication_zone)
    return false;
  return true;
}

Say_Move* Dynamic_Say_Policy::playon(){
  return Move_Factory::get_Say_Move();
}

