#include "policy_dynamic_view.h"
#include "mdp_info.h"
#include <stdlib.h>
#include <stdio.h>
#include "tools.h"
#include "valueparser.h"
#include "options.h"
#include "cmd.h"

Dynamic_View_Policy::Dynamic_View_Policy() {
  standard_view_width =Cmd_View::VIEW_ANGLE_NORMAL;
  //standard_view_width =Cmd_View::VIEW_ANGLE_NARROW;
}

#define attention_factor 1.5 // if ball is within factor * visible_dist then change

View_Move* Dynamic_View_Policy::playon(){
  
  //make sure to know where  the ball is!
  if (!mdpInfo::is_ball_pos_valid()){ 
    //printf("Missing ball pos... keep current view mode\n");
    return Move_Factory::get_View_Move();
  }
 
  if((mdpInfo::my_distance_to_ball() <= attention_factor * 
      ServerOptions::visible_distance)||
     (mdpInfo::is_ball_infeelrange_next_time())){
    if((mdpInfo::mdp->view_angle!=Cmd_View::VIEW_ANGLE_NARROW)||
       (mdpInfo::mdp->view_quality!=Cmd_View::VIEW_QUALITY_HIGH)){
      //printf("change view mode to (NARROW HIGH)\n");
      return Move_Factory::get_Change_View(Cmd_View::VIEW_ANGLE_NARROW, 
					   Cmd_View::VIEW_QUALITY_HIGH, 1);
    }
  }    
  else {
    if((mdpInfo::mdp->view_angle!=standard_view_width)||
       (mdpInfo::mdp->view_quality!=Cmd_View::VIEW_QUALITY_HIGH)){
      //printf("change view mode to (NORMAL HIGH)\n");
      return Move_Factory::get_Change_View(standard_view_width, 
					   Cmd_View::VIEW_QUALITY_HIGH, 1);
    }
  }
  
  return Move_Factory::get_View_Move();
}
