/** \file strategy_dynamic_neck
*/

#ifndef _STRATEGY_DYNAMIC_NECK_H_
#define _STRATEGY_DYNAMIC_NECK_H_

#include <stdlib.h>
#include <stdio.h>

#include "base_strategies.h"
#include "policy_factory.h"
//#include "globals.h"

class Dynamic_Neck_Strategy : public Neck_Strategy {
 protected:
 
 /** select a policy */
  virtual Neck_Policy *select_policy();
 public:
  
  /** get the current policy. */
  inline virtual Neck_Policy *get_policy(){return neck_policy;}
  /** get the move returned by policy->playon() */
  inline virtual Neck_Move *get_move(){return neck_policy->playon();}
 
  
  /** get the unique id of the strategy.
      \return strategy id.
  */ 
  inline virtual int id() {return DYNAMIC_NECK_STRATEGY;}
};

#endif //_STRATEGY_DYNAMIC_NECK_H_
