/** \file strategy_dynamic_say
*/

#ifndef _STRATEGY_DYNAMIC_SAY_H_
#define _STRATEGY_DYNAMIC_SAY_H_

#include <stdlib.h>
#include <stdio.h>

#include "base_strategies.h"
#include "policy_factory.h"
//#include "globals.h"

/** Use this strategy if you don't want the agent to perform any Say Actions.
 */
class Dynamic_Say_Strategy : public Say_Strategy {
 protected:
 
 /** select a policy */
  virtual Say_Policy *select_policy();
 public:
  
  /** get the current policy. */
  inline virtual Say_Policy *get_policy(){return say_policy;}
  /** get the move returned by policy->playon() */
  inline virtual Say_Move *get_move(){return say_policy->playon();}
 
  
  /** get the unique id of the strategy.
      \return strategy id.
  */ 
  inline virtual int id() {return DYNAMIC_SAY_STRATEGY;}
};

#endif //_STRATEGY_DYNAMIC_SAY_H_
