/** \file strategy_dynamic_view
    this view strategy calles the accelerate_view policy
*/

#ifndef _STRATEGY_DYNAMIC_VIEW_H_
#define _STRATEGY_DYNAMIC_VIEW_H_

#include <stdlib.h>
#include <stdio.h>

#include "base_strategies.h"
#include "policy_factory.h"
//#include "globals.h"

/** Use this strategy if you don't want the agent to perform any View Actions.
 */
class Dynamic_View_Strategy : public View_Strategy {
 protected:
 
 /** select a policy */
  virtual View_Policy *select_policy();
 public:
  
  /** get the current policy. */
  inline virtual View_Policy *get_policy(){return view_policy;}
  /** get the move returned by policy->playon() */
  inline virtual View_Move *get_move(){return view_policy->playon();}
 
  
  /** get the unique id of the strategy.
      \return strategy id.
  */ 
  inline virtual int id() {return DYNAMIC_VIEW_STRATEGY;}
};

#endif //_STRATEGY_DYNAMIC_VIEW_H_
