/** \file strategy_test_move
   this strategy is used to test moves in the real time coach enviroment
*/

#ifndef _STRATEGY_GO2BALL_KICK_H_
#define _STRATEGY_GO2BALL_KICK_H_

#include <stdlib.h>
#include <stdio.h>

#include "base_strategies.h"
#include "policy_factory.h"


class Go2Ball_Kick_Strategy : public Main_Strategy {
 protected:
 
 /** select a policy */
  virtual Main_Policy *select_policy();
 public:
  
  /** get the current policy. */
  inline virtual Main_Policy *get_policy(){return main_policy;}
  /** get the move returned by policy->playon() */
  inline virtual Main_Move *get_move(){return main_policy->playon();}
 
  
  /** get the unique id of the strategy.
      \return strategy id.
  */ 
  inline virtual int id() {return GO2BALL_KICK_STRATEGY;}
};

#endif //_STRATEGY_GO2BALL_KICK_H_
